#include <iostream>
#include <locale>
#include <unistd.h>
using namespace std;

int main(int argc, char *argv[]) {
   bool debug = argc > 1 && "debug" == string(argv[1]);
   locale::global(locale(""));
   while (true) {
      if (isatty(STDIN_FILENO) != 0)  
         wcout << L"Введите тестируемую строку : ";
      wstring w(L"\n");
      getline(wcin, w);
      if (w.empty()) continue;
      if (wcin.eof()) break;
      if (0 == isatty(STDIN_FILENO))  // переадресация из файла
         wcout << w << endl;      
      if (debug) wcout << L"[" << w.size() << L"]: " << w << endl;
      bool poli;
      wchar_t *pb = (wchar_t*)w.c_str(),
              *pe = pb + wcslen(pb) - 1;
      do {
         while (*pb == L' ' || !iswalnum(*pb)) pb++;
         while (*pe == L' ' || !iswalnum(*pe)) pe--;
         poli = towlower(*pb) == towlower(*pe);
         if (debug) wcout << *pb << " ? " << *pe << " = " << (poli ? "+" : "-")<< endl;
      } while (poli && ++pb <= --pe);
      wcout << L"строка " << (poli ? L"" : L"не ") << L"палиндром" << endl; 
   }
}
