#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <limits.h>
#include <stdlib.h>
#include <wchar.h>
#include <locale.h>

inline void c2w(char *c, wchar_t *w) {
   int n = -1;
   setlocale(LC_ALL, "");              // только после этого работают преобразования!
   while (n != 0)
      c += (n = mbtowc(w++, c, MB_CUR_MAX));
}

void show_str(char* pstr) {
   wchar_t wbuf [strlen(pstr) * 2];
   char *pb = pstr + strlen(pstr) - 1;
   while(*pb == ' ') *pb-- = '\0';     // удаление хвостовых пробелов
   c2w(pstr, wbuf);
   printf("%s [%ld bytes:%ld symbols]\n", 
          pstr, strlen(pstr), wcslen(wbuf));
   do 
      printf("<%02X>", (uint8_t)*pstr++);
   while (*pstr != '\0');
   printf("\n");
}

int main( int argc, char **argv ) {   
   char buf[4096], *pb;
   if (argc > 1) {
      strcpy(buf, argv[1]);
      show_str(buf);
   }
   else
      while (1) {
         if (NULL == fgets(buf, sizeof(buf) - 1, stdin)) break;
         if (1 == strlen(buf)) break;  // пустая строка
         if (index(buf, '\n') != NULL) *index(buf, '\n') = '\0';
         if (index(buf, '|') != NULL) *index(buf, '|') = '\0';      
         pb = buf;
         if (' ' == *(pb + 1)) pb +=2; // убрать нумерацию строк
         show_str(pb);
      }
   return 0;
}
