#include <iostream>
#include <locale>
#include <regex>
using namespace std;

int main(int argc, char *argv[]) {
   locale::global(locale ("ru_RU.utf8"));
   wstring wp = L"строка";
   if (argc > 1) {
      wchar_t warg[strlen(argv[1]) + 1];
      mbstowcs(warg, argv[1], strlen(argv[1]) + 1);
      wp = wstring(warg);
   }
   wregex pattern(wp, regex_constants::icase | regex_constants::awk);
   while (true) {
      wstring buf;
      getline(wcin, buf);
      if (wcin.eof() || buf.empty()) break;
      wcmatch match;                // результат сопоставления
      if (!regex_search((wchar_t*)buf.c_str(), match, pattern)) {
         wcout << "no match found" << endl
               << "--------------------" << endl;
         continue;
      }
      for (unsigned i=0; i<match.size(); ++i) {
         wcout << match.position(i) << L"/" 
               << match.position(i) + match[i].length()
               << L" : " << match[i] << endl;
      }
      wcout << "--------------------" << endl;
   }
}

